/*
 *  LibRoadnav
 *  Portability.cpp
 *
 *  Copyright (c) 2004 - 2008 Richard L. Lynch <rllynch@users.sourceforge.net>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

//////////////////////////////////////////////////////////////////////////////
/// \file
///
/// Contains function that simply porting Roadnav.
///
//////////////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif

#ifdef HAVE_CTYPE_H
#include <ctype.h>
#endif

#include <string>

using namespace std;

//////////////////////////////////////////////////////////////////////////////
///
/// \brief Compare two strings without regard for case.
/// 
/// Returns 0 on match, non-zero otherwise.
///
//////////////////////////////////////////////////////////////////////////////
int CaseInsensitiveStrCmp(const char * str1, const char * str2)
{
#if defined(HAVE_STRCASECMP)
	return strcasecmp(str1, str2);
#elif defined(HAVE_STRCMPI)
	return strcmpi(str1, str2);
#elif defined(HAVE_STRICMP)
	return stricmp(str1, str2);
#elif defined(HAVE__STRICMP)
	return _stricmp(str1, str2);
#else
	while (*str1 && *str2)
	{
		if (toupper(*str1) != toupper(*str2)) 
			break;

		str1++;
		str2++;
	}
	return toupper(*str1) - toupper(*str2);
#endif
}
